#!/usr/bin/perl --
#
#----------------------------------------------------------------------------\
# NetReg 1.3rc2
# Copyright (C) 1999-2002 Peter Valian, Southwestern University
#
# admin.cgi -- Registration Server Administrator 
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# Peter Valian <valianp@southwestern.edu>
# http://www.netreg.org/
#
# Code contributions by:
#
#   Allie M. Tate <allie@lsu.edu>, Louisiana State University
#     Lease Parser for use with dhcpd-3.0rc10
#     Variable subnet masks
#
#----------------------------------------------------------------------------/

require "../variables.pl";
require "../subnet.pl";

#----------------------------------------------------------------------------\
# Main Function
#----------------------------------------------------------------------------\
get_input();
print_header();

# Need to modify IP for hook into IPAudit
# IPAudit likes IPs in the form of xxx.xxx.xxx.xxx
if ($FORM{'src'} eq "ipaudit") {
    @OCTETS = split /\./,$FORM{'query'};
    # Cast each string of numbers into an integer -- gotta love Perl ;)
    foreach $octet (@OCTETS) {
	$octet = $octet - 0;
    }
    $FORM{'query'} = join(".",@OCTETS);
}

if    ($FORM{'action'} eq "SM") { server_manager(); }
elsif ($FORM{'action'} eq "FC") { find_conf(); }
elsif ($FORM{'action'} eq "FL") { find_lease(); }
elsif ($FORM{'action'} eq "SO") { subnet_overview(); }
elsif ($FORM{'action'} eq "VS") { view_subnet(); }
elsif (!$FORM{'action'})        { subnet_overview(); }
print_footer();
#----------------------------------------------------------------------------/


#############################################################################\
## SUBROUTINES BEGIN
#############################################################################/


#----------------------------------------------------------------------------\
# Get the input from the CGI FORM
#----------------------------------------------------------------------------\
sub get_input {
    @pairs = split(/&/, $ENV{'QUERY_STRING'});
    foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$FORM{$name} = $value;
    }
}
#----------------------------------------------------------------------------/


#----------------------------------------------------------------------------\
# Checks to see if we have a query, if not then call find_form.
# If we do have a query, grep the dhcpd conf for host entries that conatin
# the query string
#----------------------------------------------------------------------------\
sub find_conf {
    # Do we have a query, if not then print the Find Form
    if (!$FORM{'query'}) {
	find_form(FC);
    }
    # We have something to query for; look in dhcpd.conf for Query
    else {
	print "<FONT SIZE=5>Query: <B>$FORM{'query'}</B></FONT><P>\n";
	print "<img src=$GFX/small-netreg-lease.gif align=top> = Lease Info";
	print "<br><img src=$GFX/small-netreg-del.gif";
	print " align=top> = Delete User Entry<P>";
	print "<table cellpadding=10><TR><td></td><TH>User</TH>";
	print "<TH>MAC Address</TH>";
	print "<TH>Platform</TH><TH>Registration Timestamp</TH></TR>";
	my $CNT=0;
	open (DHCPDCONF, "$DHCPDCONFPATH/$DHCPDCONFFILE") or
	    error( "Cannot open DHCP conf file: $DHCPCONFPATH/$DHCPCONFFILE"),
	    print_footer(),
	    exit 0;
	my $color = get_color($color);
	while (<DHCPDCONF>) {
	    if (/^host\s.*}\#/) {
	      my ($TEMP1, $PLATFORM, $DATE, $IP) = split /\#/;
	      my ($TRASH, $USER, $TRASH, $TRASH, $TRASH, $MAC) =
		  split /\s+|\#/,$TEMP1;
	      ($USER) = split /-/,$USER;
	      # Use anchors to match a username exactly if asked to, e.g. view_subnet()
	      if ( $FORM{'exact'} ) {
		  $a1 = "\^";
		  $a2 = "\$";
	      } else {
		  $a1 = '';
		  $a2 = '';
	      }
	      if (  ($PLATFORM =~ /$FORM{'query'}/i) ||
		    ($DATE =~ /$FORM{'query'}/i) ||
		    ($IP =~ /$FORM{'query'}/) ||
		    ($USER =~ /$a1$FORM{'query'}$a2/i) ||
		    ($MAC =~ /$FORM{'query'}/i)) {
		  print "<TR><TD ALIGN=CENTER><A HREF=$ADMINPATH/admin.cgi";
		  print "\?action=FL\&query=$MAC>";
		  print "<IMG SRC=$GFX/netreg-lease.gif border=0></a>";
		  print "<TD bgcolor=$color>";

		  ($QUERY) = split /-/,$USER;
		  if ($LDAP_URL) {
		      $LDAP_URL =~ s/<USERNAME>/$QUERY/;
		      print "<A HREF=$LDAP_URL target=blank>$QUERY</A>";
		  } else {
		      print $QUERY;
		  }

		  print "</TD>";
		  $USER =~ s/$FORM{'query'}/<b>$FORM{'query'}<\/b>/;
		  $MAC =~ s/$FORM{'query'}/<b>$FORM{'query'}<\/b>/;
		  $PLATFORM =~ s/$FORM{'query'}/<b>$FORM{'query'}<\/b>/;
		  $DATE =~ s/$FORM{'query'}/<b>$FORM{'query'}<\/b>/;
		  print "<TD bgcolor=$color>$MAC</TD><TD bgcolor=$color>$PLATFORM";
		  print "</TD><TD bgcolor=$color align=center>$DATE</TD><TD>";
		  $MAC =~ s/<b>//;
		  $MAC =~ s/<\/b>//;
		  $USER =~ s/<b>//;
		  $USER =~ s/<\/b>//;
		  print "<A HREF=\"$ADMINPATH/admin.cgi\?action=FL\&";
		  print "USER=$USER\&MAC=$MAC\"";
		  print " onClick=\"ConfirmDelete(\'$ADMINPATH/admin.cgi";
		  print "\?action=FL\&USER=$USER\&MAC=$MAC\',\'$MAC\',\'$USER\')\; ";
		  print "return false\;\">";
		  print "<IMG SRC=$GFX/netreg-del.gif border=0></A></TD></TR>\n";
		  $CNT++;
		  $color = get_color($color);
	      }
	    }
        }
        print "<p>Found: <b>$CNT</b> matches<p>\n";
        close(DHCPDCONF);
        print "</table>";
    }
}
#----------------------------------------------------------------------------/

#----------------------------------------------------------------------------\
# Search for Leases; Also used to search for and delete registrations
#----------------------------------------------------------------------------\
sub find_lease {
    # Two entries with the same MAC cannot exist in the dhcpd.conf
    if (($FORM{'USER'}) && ($FORM{'MAC'})) {
	open (DHCPDCONFNEW, "$DHCPDCONFPATH/$DHCPDCONFFILE.new") or
	    error( "Cannot open new DHCP conf file: $DHCPCONFPATH/$DHCPCONFFILE.new" ),
	    print_footer(),
	    exit 0;
	while (<DHCPDCONFNEW>) {
	    # copy everything in dhcpd.conf.new over to temp variable
	    # except what we want to delete
	    if ($_ !~ /$FORM{'MAC'}/) {
		$DHCPDCONFTMP .= $_;
	    }
	}
	close(DHCPDCONFNEW);
	# now copy the dhcpd.conf.tmp file to dhcpd.conf.new 
	# refresh-dhcpdconf will take care of the rest
	open (DHCPDCONFNEW, ">$DHCPDCONFPATH/$DHCPDCONFFILE.new") or
	    error( "Cannot write new DHCP conf file: $DHCPCONFPATH/$DHCPCONFFILE.new" ),
	    print_footer(),
	    exit 0;
	print DHCPDCONFNEW $DHCPDCONFTMP;      
	close (DHCPDCONFNEW);
	print "<FONT SIZE=5>Query: <B>Delete Entry</B></FONT>";
	print "<P>Operation Complete.";

	my ($SEC) = localtime;
	my $refresh = (abs($SEC-=60))+2;
	$SEC = (abs($SEC));
	print "<BR>Database refreshing in $SEC seconds...";
	# probably need more error checking; currently just
	# continues even if dhcpd restart fails.
	print "<META HTTP-EQUIV=\"refresh\" content=\"$refresh\;";
	print "URL=$ADMINPATH/admin.cgi\">"; 
    }
    # if we don't have query data, print the Find Form
    elsif (!$FORM{'query'}) {
	find_form(FL);
    }
    # we must have data to query for in dhcpd.leases
    # will produce all leases for a host, MAC or IP (or timestamps)
    else {
	open (LEASES, "$LEASESPATH/$LEASESFILE") or
	    error( "Cannot open leases file: $LEASESPATH/$LEASESFILE" ),
	    print_footer(),
	    exit 0;
	open (TEMP, ">$LEASESPATH/$LEASESFILE.tmp") or
	    error( "Cannot open leases tmp file: $LEASESPATH/$LEASESFILE.tmp" ),
	    print_footer(),
	    exit 0;
	while (<LEASES>) {
	    if ($_ !~ /#/) {
		next if (($_ =~ /tstp/)||($_ =~ /binding/)||($_ =~ /uid|client/));
		if ($_ !~ /}/) { chomp($_); }
	    print TEMP $_;
        }
    }
    close (LEASES);
    close (TEMP);
    print "<FONT SIZE=5>Query: <B>$FORM{'query'}</B></FONT><P>";
    print "<img src=$GFX/small-netreg-user.gif align=top> = User Info";
    print "<P><TABLE CELLPADDING=10>";
    print "<TR><TH></TH><TH>MAC Address</TH><TH>IP Address</TH>";
    print "<TH>Obtained (GMT)</TH><TH>Expires (GMT)</TH></TR>\n";
    open (LEASES, "$LEASESPATH/$LEASESFILE.tmp") or
	error( "Cannot open leases tmp file: $LEASESPATH/$LEASESFILE.tmp" ),
	print_footer(),
	exit 0;
    my $CNT = 0;
    while (<LEASES>) {
        if ($_ =~ /$FORM{'query'}\W/i) {
	    push (@leases, $_);
	    foreach $lease (@leases) {
		($TRASH, $IP, $TRASH, $TRASH, $TRASH, $TRASH, $DATESTART, 
		 $TIMESTART, $TRASH, $TRASH, $TRASH, $DATEEND, $TIMEEND, $TRASH, 
		 $TRASH, $TRASH, $MAC) = split /\s+|\{|\;|\}/,$lease;
		$LEASE_HASH{$IP}="$DATESTART,$TIMESTART,$DATEEND,$TIMEEND,$MAC";
	  }
          $MAC=uc($MAC);
          $color = get_color($color);
          print "<tr><td align=center><A HREF=$ADMINPATH/admin.cgi";
          print "\?action=FC\&query=$MAC>";
          print "<img src=/gfx/netreg-user.gif border=0></a></td>";
          $MAC =~ s/$FORM{'query'}/<b>$FORM{'query'}<\/b>/g;
          $IP =~ s/$FORM{'query'}/<b>$FORM{'query'}<\/b>/g;
          $DATESTART =~ s/$FORM{'query'}/<b>$FORM{'query'}<\/b>/g;
          $TIMESTART =~ s/$FORM{'query'}/<b>$FORM{'query'}<\/b>/g;
          $DATEEND =~ s/$FORM{'query'}/<b>$FORM{'query'}<\/b>/g;
          $TIMEEND =~ s/$FORM{'query'}/<b>$FORM{'query'}<\/b>/g;
          print "<td bgcolor=$color>$MAC</td><td bgcolor=$color>$IP</td>";
          print "<td bgcolor=$color>$DATESTART $TIMESTART</td>";
          print "<td bgcolor=$color>$DATEEND $TIMEEND</td></tr>\n";
          $CNT++;
        }
      }
      print "<p>Found: <b>$CNT</b> matches<p>\n";
      close(LEASES);
      print "</TABLE>";
    }
  }
#----------------------------------------------------------------------------/

#----------------------------------------------------------------------------\
# Simple search form called by FL, FC
#----------------------------------------------------------------------------\
sub find_form {
    my $action = shift(@_);
    if ($action eq "FL") {
	print "<font size=4>Search Leases</font><br>";
	print "<font size=2>(IP, MAC, Lease Start, Lease End)</font><P>";
    }
    else {
	print "<font size=4>Search Registration Database</font><br>";
	print "<font size=2>(User, MAC, Platform, Registration Timestamp)";
	print "</font><P>";
    }
    print "<form method=get action=$ADMINPATH/admin.cgi>";
    print "<input type=hidden name=action value=$action>";
    print "<input type=text name=query><P>";
    print "<input type=submit>";
}
#----------------------------------------------------------------------------/

#----------------------------------------------------------------------------\
# grep for the servers' running PID and Time Start
# Note, PID and Time Start for HTTPD doesn't really make sense as
# HTTPD launches several children...the first one is listed, thats enough to
# know the server is up.
#----------------------------------------------------------------------------\
sub server_manager {
    print "<font size=5>Server Manager</font><P>";
    $UPTIME = `uptime`;
    print "$UPTIME<P>";
    $PID1=`ps auxw|grep dhcpd|grep -v grep|awk \'\{print \$2\ " -- " \$9}\'`;
    chomp ($PID1);
    if ($PID1 ne "") {
      $status = "UP";
      $color="green";
    }
    else {
      $status = "DOWN";
      $color="red";
    }
    print "The DHCP server is ";
    print "<font color=$color>$status</font>.<br>Running as process: $PID1";

    $PID1=`ps auxw|grep named|grep -v grep|awk \'\{print \$2\ " -- " \$9\}\'`;
    chomp ($PID1);
    if ($PID1 ne "") {
      $status = "UP";
      $color="green";
    }
    else {
      $status = "DOWN";
      $color="red";
    }
    print "<p>The DNS server is ";
    print "<font color=$color>$status</font>.<br>Running as process: $PID1";


    my $PID1=`ps auxw|grep httpd|grep -v grep|awk \'\{print \$2\}\'`;
    chomp ($PID1);
    ($PID1) = split / +|\s|\t/,$PID1;
    if ($PID1 ne "") {
      $status = "UP";
      $color="green";
    }
    else {
      $status = "DOWN";
      $color="red";
    }
    print "<p>The HTTP server is ";
    print "<font color=$color>$status</font>.<br>Running as process: $PID1";
}
#----------------------------------------------------------------------------/

#----------------------------------------------------------------------------\
# grep the dhcpd.conf for the specified subnet
# NOTE: not selecting a subnet will print all the subnets
#----------------------------------------------------------------------------\
sub view_subnet {
    parse_subnets();

    print "<font size=5>Subnet Overview: <b>$FORM{'subnet'}</b><P>";
    print "<img src=$GFX/small-netreg-lease.gif align=top> = Lease Info";
    print "<br><img src=$GFX/small-netreg-user.gif align=top> = User Info";
    print "<br><img src=$GFX/small-netreg-del.gif";
    print " align=top> = Delete User Entry";
    print "<table cellpadding=10><TR><td></td><TH>User</TH><TH>MAC Address";
    print "</TH><TH>Platform</TH><TH>Registration Timestamp</TH>";
    print "<TH></TH></TR>";
    open (DHCPDCONF, "$DHCPDCONFPATH/dhcpd.conf") or
      error( "Cannot open DHCP conf file: $DHCPCONFPATH/$DHCPCONFFILE"),
      print_footer(),
      exit 0;
    my @entries;
    while (<DHCPDCONF>) {
	if (/^host\s.*\#(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/) {
	    if (ip_in_subnet($1,$URSUBS{$FORM{'subnet'}})) {
		($DATA1, $PLATFORM, $DATE, $IP) = split /\#/;
		($TRASH,$USER,$TRASH,$TRASH,$TRASH,$MAC) = split /\s+|\#/,$DATA1;
		($QUERY) = split /-/,$USER;
		push(@entries,join('#',($QUERY,$MAC,$PLATFORM,$DATE,$IP)));
	    }
	}
    }

    @entries = sort( @entries );
    my $i;
    for ($i=0; $i<=$#entries; $i++) {
	$color = get_color($color);
	($QUERY,$MAC,$PLATFORM,$DATE,$IP) = split( '#', $entries[$i] );
	print "<TR><TD ALIGN=CENTER><A HREF=$ADMINPATH/admin.cgi";
	print "\?action=FL\&query=$MAC>";
	print "<IMG SRC=$GFX/netreg-lease.gif border=0 hspace=2></a>";
	#Ask for an exact match to avoid similar usernames
	print "<A HREF=$ADMINPATH/admin.cgi\?action=FC\&query=$QUERY&exact=1>";
	print "<IMG SRC=$GFX/netreg-user.gif border=0></A></TD>";
	print "<TD bgcolor=$color>";
	if ($LDAP_URL) {
	    $LDAP_URL =~ s/<USERNAME>/$QUERY/;
	    print "<a href=$LDAP_URL target=blank>$QUERY</a>";
	} else {
	    print $QUERY;
	}
	print "</TD><TD bgcolor=$color>$MAC</TD>";
	print "<TD bgcolor=$color>$PLATFORM</TD>";
	print "<TD bgcolor=$color align=center>$DATE";
	print "<br>$TIME</TD><TD ALIGN=CENTER>";
	$MAC =~ s/<b>//;
	$MAC =~ s/<\/b>//;
	$USER =~ s/<b>//;
	$USER =~ s/<\/b>//;
	print "<A HREF=\"\#\" onClick=\"ConfirmDelete(\'$ADMINPATH/admin.cgi";
	print "\?action=FL\&USER=$USER\&MAC=$MAC\',\'$MAC\',\'$USER\')\; ";
	print "return false\;\">";
	print "<IMG SRC=$GFX/netreg-del.gif border=0></A></TD></TR>\n";
    }
    print "</table>";
}
#----------------------------------------------------------------------------/

#----------------------------------------------------------------------------\
# gets a line count of how many clients on each subnet
# prints out a table listing from subnet.dat of all the
# subnets and host entries in dhcpd.conf
#----------------------------------------------------------------------------\
sub subnet_overview {
    my $TOTAL = 0;
#    my $test = bad_subnet($ALLOW_DOMAIN);
#    if ($test) {
#        error($test);
#    }
    parse_subnets();

    print "<table border=0><tr><Th></th><TH align=center>";
    print "<font size=5>Subnet Overview</font>";
    print "<P>Current Registered<br>DHCP Hardware</th><th></th></tr>\n";

    foreach $subnet (keys %LOC) {
	print "Subnet: $subnet $LOC{$subnet}\<br\>\n";
    }

    open(DHCPDCONF, "$DHCPDCONFPATH/dhcpd.conf") or
      error( "Cannot open DHCP conf file: $DHCPCONFPATH/$DHCPCONFFILE"),
      print_footer(),
      exit 0;
    @CONFILE = <DHCPDCONF>;
    close (DHCPDCONF);

    foreach $SUBNET(sort { $a <=> $b; } keys %LOCS) {
	@LOCS= split (/:/, $LOCS{$SUBNET});
	foreach $LOC(@LOCS) {
	    $CNT=0;
	    foreach $LINE (@CONFILE) {
		if ($LINE =~ /^host\s.*\#(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/) {
		    $CNT++ if (ip_in_subnet($1,$URSUBS{$SUBNET}));
		}
	    }

	    chomp($LOC);
	    print "<tr><td align=right>";
	    print "<a href=$ADMINPATH/admin.cgi?action=VS&subnet=$SUBNET>";
	    print "$SUBNET</a></td>";
	    print "<td width=255 bgcolor=\#DCDCEE>";
	    $barwidth = ($CNT * 255)/$SUBIPS{$SUBNET} + 1;
	    if ($barwidth > 255) {
		$barwidth = 255;
	    }
	    print "<img lowsrc=$GFX/meter.gif src=$GFX/meter.jpg height=5 width=$barwidth border=1 hspace=2>";
	    print "$CNT</td><td><a ";
	    print "href=$ADMINPATH/admin.cgi?action=VS&subnet=$SUBNET>$LOC</a>";
	    print "</td></tr>\n";
	    $TOTAL += $CNT;
	}
    }
    # The following takes advantage of a *feature/bug* in Netscape that
    # prints data in a table without a <TR> at the top of the table.
    # IE users see this at the bottom of their table :(
    print "</th><th></th></tr><center><b>$TOTAL Total ";
    print "Registered Clients</b><p></center></table></form>";
}

#----------------------------------------------------------------------------/

#----------------------------------------------------------------------------\
# Alternate colors for table rows
#----------------------------------------------------------------------------\
  sub get_color {
    my $color = shift(@_);
    if ($color eq "A9A9D4") { $color = "FFD1D1"; }
    else { $color = "A9A9D4"; }
    return ($color);
  }
#----------------------------------------------------------------------------/

#----------------------------------------------------------------------------\
# Print out the error message
#----------------------------------------------------------------------------\
  sub error {
    $ERROR_MSG = shift(@_);
    print "<TABLE WIDTH=350 border=0 cellspacing=0 cellpadding=1><TR>";
    print "<TH BGCOLOR=black><table width=348 cellpadding=5";
    print "cellspacing=0 align=center><TR><TH bgcolor=black>";
    print "<font color=white size=5><b>Script Error</b></FONT></th>";
    print "</tr><tr><th bgcolor=\#DDD7FF>$ERROR_MSG</center><P>";
    print "</td></tr></table></th></tr></table>";
  }


#----------------------------------------------------------------------------\
# Print HTML Header
#----------------------------------------------------------------------------\
  sub print_header {
    print "content-type: text/html\n\n";
    print "<HTML><HEAD><TITLE>NetReg</TITLE>";
    print "<META HTTP-EQUIV=\"PRAGMA\" CONTENT=\"no-cache\">";
    print "<Script Language=\"JavaScript\"><\!--\n"; 
    print "function ConfirmDelete(URL,MAC,USER) {\n";
    print "answer=confirm(\"Are you sure you want to delete \"+MAC+\" ";
    print "which is registered to \"+USER+\"?\")\n";
    print "if(answer !=0) { location = URL; } }\n";
    print "// --></script></HEAD>\n";
    print "<BODY BGCOLOR=WHITE><CENTER>";
    print "<IMG SRC=$GFX/netreg-top-logo.gif><BR>";
    print "<IMG SRC=$GFX/netreg-menu.gif USEMAP=\#menu BORDER=0><P>";
  }
#----------------------------------------------------------------------------/

#----------------------------------------------------------------------------\
# Print HTML Footer
#----------------------------------------------------------------------------\
  sub print_footer {
    print "<P><img src=$GFX/netreg-menu.gif usemap=\#menu border=0>";
    print "<map name=menu>";
    print "<area shape=rect coords=0,0,140,13 ";
    print "href=$ADMINPATH/admin.cgi\?action=SO>";
    print "<area shape=rect coords=140,0,360,13 ";
    print "href=$ADMINPATH/admin.cgi\?action=FC>";
    print "<area shape=rect coords=360,0,515,13 ";
    print "href=$ADMINPATH/admin.cgi\?action=FL>";
    print "<area shape=rect coords=515,0,647,13 ";
    print "href=$ADMINPATH/admin.cgi\?action=SM>";
    print "<AREA SHAPE=DEFAULT NOHREF></map><BR>";
    print "<IMG SRC=$GFX/netreg-bottom-logo.gif><BR><FONT SIZE=2>";
    print "<a href=\"http://www.netreg.org/\">NetReg";
    print " v1.3</a> &copy;2002 Lawrence University</FONT>";
    print "</BODY></HTML>";
    exit;
  }
#----------------------------------------------------------------------------/
